       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGAUT. 
      *
      *    Interfaccia ANAAUT per scheda
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'griautsl'.
           COPY 'gritabsl'.
      **** rel 7.2
           COPY 'griaausl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'griaut'.
           COPY 'gritab'.
      **** rel 7.2
           COPY 'griaau'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'griconrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 1.2
      *    COPY 'rfisc'.
      *    COPY 'rpiva'.
           COPY 'prfisc'.
           COPY 'prpiva'.
      ************
      **** rel 7.1
           COPY 'parppar'.
      ************
      **** rel 7.2
           COPY 'parmb'.
      ************
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-AUT PIC X(15) VALUE 'anaaut'.
      **** rel 7.2
       01  ID-AAU PIC X(15) VALUE 'appaut'.
      ************
       01  COMODI.
           05 SF-CLF   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CON   PIC XX.
           05 SF-AUT   PIC XX.
      **** rel 7.2
           05 SF-AAU   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(50).
           05 IF-AZI   PIC 9(3).
           05 K        PIC 99.
           05 FLAG-FIS PIC 9.
           05 CODFOR.
              10 MAS   PIC 99.
              10 COD   PIC 9(5).
           05 COMCON.
              10 COMCON1 PIC 99.
              10 COMCON2 PIC 9(5).
           05 VETMES  PIC X(12) VALUE 'ABCDEHLMPRST'.
           05 NUMMES  REDEFINES VETMES PIC X OCCURS 12.
           05 CDFISC  PIC X(16).
           05 DTFISC  REDEFINES CDFISC.
              10 FILLER PIC X(6).
              10 AN     PIC XX.
              10 ANM REDEFINES AN PIC 99.
              10 MS     PIC X.
              10 GI     PIC XX.
              10 GIM REDEFINES GI PIC 99.
              10 FILLER PIC X(5).
           05 DTFIVA  REDEFINES CDFISC.
              10 NUM    PIC X(11).
              10 BLK    PIC X(5).
       LINKAGE SECTION.
           COPY 'griautrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-AUT-CTRL
                                RG-AUT-REC
                                RA-AUT-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclaut'.
           COPY 'dcltab'.
      **** rel 7.2
           COPY 'dclaau'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-AUT-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-AUT-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           IF (RG-AUT-FUN = 'N' OR 'n') AND
              (RG-AUT-EOF = 2 OR 3)     GO TO ESCI.
           IF (RG-AUT-FUN = 'P' OR 'p') AND
              (RG-AUT-EOF = 1 OR 2)     GO TO ESCI.
           MOVE RG-AUT-FUN   TO FUN.
           MOVE RG-AUT-IDX   TO IDX.
           MOVE RG-AUT-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-AUT-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vrgaut: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-AUT-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-AUT-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-AUT-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
      *    PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK ANAAUT.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
      *    PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-AUT INVALID
              PERFORM INVK-AUT
              GO TO ERRIO.
      **** rel 7.2
           MOVE KEYAT TO KEYAAU.
           WRITE RF-AAU INVALID 
                 PERFORM INVK-AAU
                 GO TO ERRIO.
      ************
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
      *    PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-AUT INVALID
              PERFORM INVK-AUT
              GO TO ERRIO.
      **** rel 7.2
           MOVE KEYAT TO KEYAAU.
           REWRITE RF-AAU INVALID 
                WRITE RF-AAU INVALID 
                    PERFORM INVK-AAU
                    GO TO ERRIO.
      ************
           UNLOCK ANAAUT.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-AUT
              GO TO WARNING.
           IF RG-AUT-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           DELETE ANAAUT INVALID
              PERFORM INVK-AUT
              GO TO ERRIO.
      **** rel 7.2
           MOVE KEYAT TO KEYAAU.
           DELETE APPAUT.
      ************
           UNLOCK ANAAUT.
      **** rel 4.1a
           MOVE KEYAT TO KEYCF.
           READ ANACLF INTO REKCLF INVALID GO TO FINE.
           IF CLF-FLAUT = ZERO GO TO FINE.
           IF CLF-FLAUT = 1
              MOVE ZERO TO CLF-FLAUT
              REWRITE RF-CLF FROM REKCLF INVALID PERFORM INVK-CLF
                                                 GO TO ERRIO.
      ************
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-AUT-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK ANAAUT.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-AUT-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL.
           CLOSE ANAAUT.
           CLOSE ANACLF.
           CLOSE ANACON.
      **** rel 7.2
           CLOSE APPAUT.
      ************
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-AUT-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-AUT-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griconer'.
           COPY 'griclfer'.
           COPY 'griauter'.
           COPY 'gritaber'.
      **** rel 7.2
           COPY 'griaauer'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
      **** rel 4.0-2
           MOVE 'anaclf' TO ID-CLF.
           MOVE 'anacon' TO ID-CON.
      ************
           OPEN INPUT TABELL.
           OPEN  I-O  ANACON.
           OPEN  I-O  ANACLF.
           OPEN  I-O  ANAAUT.
      **** rel 7.2
           OPEN  I-O  APPAUT.
      ************
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MFOR TO MAS.
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-AUT-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO  TO RF-AUT.
           MOVE ZERO  TO AUT-DNA.
           MOVE SPACE TO AUT-RGSOC
                         AUT-FIS
                         AUT-RGS
                         AUT-CNA
                         AUT-PNA
                         AUT-SES
                         AUT-CDO
                         AUT-PDO
                         AUT-IND
      **** rel 7.2
                         AAU-PDO2
                         AAU-CDO2
                         AAU-IND2
                         AAU-CCOM1
                         AAU-CCOM2
                         AAU-CFUS
                         AAU-CFUSD
      ************
                         AUT-ATT
                         AUT-FSE.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-AUT-AZI TO IF-AZI.

      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-AUT-REC.
           MOVE SPACE TO RG-AUT-CGN
                         RG-AUT-NOM
                         RG-AUT-RGSOC
                         RG-AUT-FIS
                         RG-AUT-RGS
                         RG-AUT-CNA
                         RG-AUT-PNA
                         RG-AUT-SES
                         RG-AUT-CDO
                         RG-AUT-PDO
                         RG-AUT-IND
      **** rel 7.2
                         RG-AUT-CDO2
                         RG-AUT-PDO2
                         RG-AUT-IND2
                         RG-AUT-CCOM1
                         RG-AUT-CCOM2
                         RG-AUT-CFUS
                         RG-AUT-CFUSD
      ************
                         RG-AUT-ATT
                         RG-AUT-FSE.

           MOVE ZERO  TO RA-AUT-AGG.
           MOVE SPACE TO RA-AUT-COD5-D
                         RA-AUT-COD7-D
                         RA-AUT-RGS-ARCH
                         RA-AUT-IND-ARCH
                         RA-AUT-RGS2-ARCH
                         RA-AUT-IND2-ARCH.

      * ripristino dei campi chiave fissi
           MOVE IF-AZI TO RG-AUT-AZI.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           MOVE 1 TO RA-AUT-TPMS
                     RG-AUT-TIP.
      **** rel 1.2
           MOVE 'M' TO RG-AUT-ATT RG-AUT-SES.
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
           GO TO END-INS-OK
                 INS-OK-CON
                 INS-OK-FOR DEPENDING RA-AUT-TPMS.
      *
       INS-OK-CON.
           MOVE CON-DSC TO RG-AUT-RGSOC
                           RA-AUT-RGS-ARCH.
           GO TO END-INS-OK.
      *
       INS-OK-FOR.
           MOVE CLF-RGSOC TO RG-AUT-RGSOC RA-AUT-RGS-ARCH.
           MOVE CLF-RGSOC2 TO RA-AUT-RGS2-ARCH.
           MOVE CLF-INDIR TO RG-AUT-IND RA-AUT-IND-ARCH.
           MOVE CLF-INDIR2 TO RA-AUT-IND2-ARCH.
           MOVE CLF-CIT TO RG-AUT-CDO.
           MOVE CLF-PRV TO RG-AUT-PDO.
           MOVE CLF-CFISC TO CDFISC RG-AUT-FIS.
           MOVE CLF-13IVA TO RG-AUT-TIP.
      **** rel 4.0
           IF RG-AUT-TIP = 4 MOVE 1 TO RG-AUT-TIP.
      ************
           IF CDFISC = SPACE GO TO END-INS-OK.
           IF BLK = SPACE 
              IF NUM NUMERIC
                 MOVE 1 TO RG-AUT-TIP
              END-IF
              GO TO END-INS-OK.
           IF NOT (AN NUMERIC AND GI NUMERIC) GO TO END-INS-OK.
           MOVE ZERO TO K.
       INS-OK-FOR-20.
           ADD 1 TO K.
           IF K > 12 GO TO END-INS-OK.
           IF MS NOT = NUMMES (K) GO TO INS-OK-FOR-20.
           MOVE K      TO MM9.
           MOVE ANM    TO AA9.
           MOVE GIM    TO GG9.
           IF GG9 > 31
              SUBTRACT 40 FROM GG9
              MOVE 'F' TO RG-AUT-SES
           ELSE
              MOVE 'M' TO RG-AUT-SES.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO
              MOVE SPACE TO RG-AUT-SES
              GO TO END-INS-OK.
      **** rel 4.1
      *    MOVE GGMMAA TO RG-AUT-DNA.
           MOVE GGMMAA4 TO RG-AUT-DNA.
      ************
           MOVE 2 TO RG-AUT-TIP.
       END-INS-OK.
      *
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-AUT-AZI TO KAT-AZI.
           MOVE RG-AUT-COD TO KAT-COD.
           MOVE KEYAT TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYAT.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ ANAAUT INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
      **** rel 7.2
           MOVE KEYAT TO KEYAAU.
           READ APPAUT INVALID 
                PERFORM SCRIVI-AAU THRU EX-SCRIVI-AAU.
      ************
           GO TO EX-READ-K.
      *
       RDK-10.
           READ ANAAUT KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
      **** rel 7.2
           MOVE KEYAT TO KEYAAU.
           READ APPAUT INVALID 
                PERFORM SCRIVI-AAU THRU EX-SCRIVI-AAU.
      ************
           IF SF-AUT > ZERO MOVE 7 TO RG-AUT-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
      * posizionamento su chiave secondaria per successive
      * read next/previous
      *
       SET-KEYSEC.
           MOVE KEYAT TO KRIFER.
           START ANAAUT KEY >= KEYAT2 INVALID GO TO SET-90.
       SET-10.
           READ ANAAUT NEXT AT END GO TO SET-90.
           IF KEYAT = KRIFER GO TO EX-SET-KEYSEC.
           GO TO SET-10.
       SET-90.
           MOVE 'vrgaut: errore di posizionamento su' TO F-MES1.
           MOVE 'chiave secondaria'                   TO F-MES2.
           MOVE 2 TO F-NMES.
           GO TO ERRIO.
       EX-SET-KEYSEC.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
           IF IDX > 1 PERFORM SET-KEYSEC THRU EX-SET-KEYSEC.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ ANAAUT PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ ANAAUT NEXT AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-AUT = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *
           IF KAT-AZI NOT = RG-AUT-AZI GO TO RNP-10.

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-AUT-EOF.
           MOVE KEYAT TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-AUT-EOF.
           IF RG-AUT-EOF = 4 MOVE 2 TO RG-AUT-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-AUT = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
           IF KAT-AZI = RG-AUT-AZI GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-AUT-AZI       TO KAT-AZI.
           MOVE RG-AUT-COD       TO KAT-COD.
      *
           IF RG-AUT-TIP = 2
              MOVE RG-AUT-CGN TO AUT-CGN
              MOVE RG-AUT-NOM TO AUT-NOM
           ELSE
              MOVE RG-AUT-RGSOC TO AUT-RGSOC.
      *
           MOVE RG-AUT-FIS    TO AUT-FIS.
           MOVE RG-AUT-TIP    TO AUT-TIP.
           MOVE RG-AUT-RGS    TO AUT-RGS.
           MOVE RG-AUT-CNA    TO AUT-CNA.
      *
           IF RA-AUT-FLGNEST = 1
              MOVE 'EE'       TO AUT-PNA
           ELSE
              MOVE RG-AUT-PNA TO AUT-PNA.
      *
      **** rel 4.1
      *    MOVE RG-AUT-DNA TO GGMMAA.
      *    MOVE 1 TO TIPOP1.
           MOVE RG-AUT-DNA TO GGMMAA4.
           MOVE 4 TO TIPOP1.
      ************
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO AUT-DNA.
      *
           MOVE RG-AUT-SES    TO AUT-SES.
           MOVE RG-AUT-CDO    TO AUT-CDO.
      *
           IF RA-AUT-FLGDEST = 1
              MOVE 'EE'       TO AUT-PDO
           ELSE
      **** rel 1.2
      *       MOVE RG-AUT-PNA TO AUT-PDO.
              MOVE RG-AUT-PDO TO AUT-PDO.
      ************
      *
           MOVE RG-AUT-IND    TO AUT-IND.
           MOVE RG-AUT-ATT    TO AUT-ATT.
           MOVE RG-AUT-FSE    TO AUT-FSE.
           MOVE RG-AUT-CDE    TO AUT-CDE.
      **** rel 7.2
           MOVE RG-AUT-CDO2   TO AAU-CDO2.
           MOVE RG-AUT-PDO2   TO AAU-PDO2.
           MOVE RG-AUT-IND2   TO AAU-IND2.
           MOVE RG-AUT-CCOM1  TO AAU-CCOM1.
           MOVE RG-AUT-CCOM2  TO AAU-CCOM2.
           MOVE RG-AUT-CFUS   TO AAU-CFUS.
           MOVE RG-AUT-CFUSD  TO AAU-CFUSD.
           MOVE RG-AUT-FORZA  TO AAU-FORZA.
           MOVE RG-AUT-SHUM   TO AAU-SHUM.
      ************
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE KAT-AZI    TO RG-AUT-AZI.
           MOVE KAT-COD    TO RG-AUT-COD.
      *
           IF AUT-TIP = 2
              MOVE AUT-CGN TO RG-AUT-CGN
              MOVE AUT-NOM TO RG-AUT-NOM
              MOVE SPACE   TO RG-AUT-RGSOC
           ELSE
              MOVE AUT-RGSOC TO RG-AUT-RGSOC
              MOVE SPACE     TO RG-AUT-CGN
                                RG-AUT-NOM.
      *
           MOVE AUT-FIS    TO RG-AUT-FIS.
           MOVE AUT-TIP    TO RG-AUT-TIP.
           MOVE AUT-RGS    TO RG-AUT-RGS.
           MOVE AUT-CNA    TO RG-AUT-CNA.
           MOVE AUT-PNA    TO RG-AUT-PNA.
      *
           MOVE AUT-DNA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 1.2
      *    MOVE GGMMAA TO AUT-DNA.
      **** rel 4.1
      *    MOVE GGMMAA TO RG-AUT-DNA.
           MOVE GGMMAA4 TO RG-AUT-DNA.
      ************
      ************
      *
           MOVE AUT-SES    TO RG-AUT-SES.
           MOVE AUT-CDO    TO RG-AUT-CDO.
           MOVE AUT-PDO    TO RG-AUT-PDO.
           MOVE AUT-IND    TO RG-AUT-IND.
      **** rel 7.2
           MOVE AAU-CDO2   TO RG-AUT-CDO2.
           MOVE AAU-PDO2   TO RG-AUT-PDO2.
           MOVE AAU-IND2   TO RG-AUT-IND2.
           MOVE AAU-CCOM1  TO RG-AUT-CCOM1.
           MOVE AAU-CCOM2  TO RG-AUT-CCOM2.
           MOVE AAU-CFUS   TO RG-AUT-CFUS.
           MOVE AAU-CFUSD  TO RG-AUT-CFUSD.
           MOVE AAU-FORZA  TO RG-AUT-FORZA.
           MOVE AAU-SHUM   TO RG-AUT-SHUM.
      ************
           MOVE AUT-ATT    TO RG-AUT-ATT.
           MOVE AUT-FSE    TO RG-AUT-FSE.
           MOVE AUT-CDE    TO RG-AUT-CDE.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           MOVE ZERO  TO RA-AUT-AGG.
           MOVE SPACE TO RA-AUT-COD5-D
                         RA-AUT-COD7-D
                         RA-AUT-RGS-ARCH
                         RA-AUT-IND-ARCH
                         RA-AUT-RGS2-ARCH
                         RA-AUT-IND2-ARCH.

      *
           MOVE KAT-COD TO COMCON.
           IF COMCON1 = ZERO 
              MOVE 1 TO RA-AUT-TPMS
              GO TO CARICA-RA-20.
           IF COMCON1 NOT = MAS GO TO CARICA-RA-10.
           MOVE KEYAT TO KEYCF.
           READ ANACLF INTO REKCLF INVALID
                MOVE ALL '*' TO RA-AUT-RGS-ARCH
                GO TO CARICA-RA-20.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-RGSOC TO RA-AUT-RGS-ARCH.
           MOVE CLF-RGSOC2 TO RA-AUT-RGS2-ARCH.
           MOVE CLF-INDIR TO RA-AUT-IND-ARCH.
           MOVE CLF-INDIR2 TO RA-AUT-IND2-ARCH.
           IF CLF-FLAUT = ZERO
              MOVE ZERO TO RA-AUT-TEST
           ELSE
              MOVE 1    TO RA-AUT-TEST.
           MOVE 3 TO RA-AUT-TPMS.
           GO TO CARICA-RA-20.
       CARICA-RA-10.
           MOVE KEYAT TO KEYPC.
           READ ANACON INTO REKCON INVALID
                MOVE ALL '*' TO RA-AUT-RGS-ARCH
                GO TO CARICA-RA-20.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF CON-MOVIM = 1
              MOVE 'Conto non movimentabile' TO RA-AUT-IND-ARCH.
           MOVE CON-DSC TO RA-AUT-RGS-ARCH.
           IF CON-FLAUT = ZERO
              MOVE ZERO TO RA-AUT-TEST
           ELSE
              MOVE 1    TO RA-AUT-TEST.
           MOVE 2 TO RA-AUT-TPMS.
       CARICA-RA-20.
           MOVE AUT-DNA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 4.1
      *    MOVE GGMMAA TO RG-AUT-DNA.
           MOVE GGMMAA4 TO RG-AUT-DNA.
      ************
           IF AUT-PDO = 'EE' MOVE 1 TO RA-AUT-FLGDEST.
      **** rel 7.2
           IF AAU-PDO2 = 'EE' MOVE 1 TO RA-AUT-FLGDEST2.
      ************
           IF AUT-PNA = 'EE' MOVE 1 TO RA-AUT-FLGNEST.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-AUT-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-TPMS.
           MOVE 'AUT-TPMS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPMS.
           IF RA-AUT-TPMS < 1 OR > 3
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPMS.
      *
       V-COD5.
           MOVE 'AUT-COD5' TO VCAMPO.
           MOVE SPACE TO RA-AUT-COD5-D.
           IF NOT (RA-AUT-TPMS = 1 OR 3) GO TO E-COD5.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD5.
           IF RA-AUT-COD5 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF RA-AUT-TPMS NOT = 3 
              MOVE RA-AUT-COD5 TO COMCON2
              MOVE ZERO        TO COMCON1
              MOVE COMCON      TO RG-AUT-COD
              GO TO E-COD5.
           MOVE RA-AUT-COD5 TO COD.
           MOVE CODFOR      TO KCF-COD.
           MOVE RG-AUT-AZI  TO KCF-AZI.
           READ ANACLF INTO REKCLF INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-RGSOC TO RA-AUT-COD5-D.
           MOVE CODFOR    TO RG-AUT-COD.
       E-COD5.
      *
       V-COD7.
           MOVE 'AUT-COD7' TO VCAMPO.
           MOVE SPACE TO RA-AUT-COD7-D.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD7.
           IF RA-AUT-TPMS NOT = 2 GO TO E-COD7.
           IF RA-AUT-COD7 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE RA-AUT-COD7 TO COMCON.
           IF COMCON1 = MAS
              PERFORM ERR-DINV
              GO TO V-ERROR.
           MOVE RA-AUT-COD7 TO KPC-COD.
           MOVE RG-AUT-AZI  TO KPC-AZI.
           READ ANACON INTO REKCON INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF CON-MOVIM = 1
              MOVE 'Conto non movimentabile' TO MESS
              GO TO V-ERROR.
           MOVE CON-DESCR   TO RA-AUT-COD7-D.
           MOVE RA-AUT-COD7 TO RG-AUT-COD.
       E-COD7.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-AUT-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
           MOVE ZERO TO FLAG-FIS.
      *
       V-FIS.
           MOVE 'AUT-FIS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FIS.
           IF RG-AUT-FIS = SPACE GO TO E-FIS.
           MOVE RG-AUT-FIS TO CDFISC.
           IF NOT (BLK = SPACE AND NUM NUMERIC) GO TO V-FIS-00.
           MOVE ZERO TO RISPIVA.
           MOVE NUM  TO CODPIVA.
           CALL 'rpiva' USING PARPIVA.
           IF RISPIVA = ZERO
              MOVE 1 TO RG-AUT-TIP
              GO TO E-FIS.
       V-FIS-CNF.
           MOVE 1 TO FLAG-FIS.
           GO TO E-FIS.
       V-FIS-00.
           MOVE ZERO TO RISPFISC.
           MOVE CDFISC TO COMFISC.
           IF AN NOT NUMERIC OR GI NOT NUMERIC GO TO V-FIS-CNF.
           CALL 'rfisc' USING PARFISC.
           IF RISPFISC NOT = ZERO GO TO V-FIS-CNF.
           MOVE 2 TO RG-AUT-TIP.
           MOVE ZERO TO K.
           IF KAT-AZI NOT = ZERO GO TO E-FIS.
           IF FUN NOT = 'V' GO TO E-FIS.
       V-FIS-10.
           ADD 1 TO K.
           IF K > 12 GO TO E-FIS.
           IF MS NOT = NUMMES(K) GO TO V-FIS-10.
           MOVE K      TO MM9.
           MOVE ANM    TO AA9.
           MOVE GIM    TO GG9.
           IF GG9 > 31
              SUBTRACT 40 FROM GG9
              MOVE 'F' TO RG-AUT-SES
           ELSE
              MOVE 'M' TO RG-AUT-SES.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO MOVE SPACE TO RG-AUT-SES
                                GO TO E-FIS.      
      **** rel 4.1
      *    MOVE GGMMAA TO RG-AUT-DNA.
           MOVE GGMMAA4 TO RG-AUT-DNA.
      ************
       E-FIS.
      *
       V-TIP.
           MOVE 'AUT-TIP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIP.
           IF NOT (RG-AUT-TIP = 1 OR 2 OR 3)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TIP.
      *
       V-RGSOC.
           MOVE 'AUT-RGSOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-RGSOC.
           IF RG-AUT-TIP = 2 GO TO E-RGSOC.
           IF RG-AUT-RGSOC = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-RGSOC.
      *
       V-RGS.
           MOVE 'AUT-RGS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-RGS.
           IF RG-AUT-TIP = 2 GO TO E-RGS.
       E-RGS.
      *
       V-CGN.
           MOVE 'AUT-CGN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CGN.
           IF RG-AUT-TIP NOT = 2 GO TO E-CGN.
           IF RG-AUT-CGN = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CGN.
      *
       V-NOM.
           MOVE 'AUT-NOM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NOM.
           IF RG-AUT-TIP NOT = 2 GO TO E-NOM.
           IF RG-AUT-NOM = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-NOM.
      *
       V-DNA.
           MOVE 'AUT-DNA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DNA.
           IF RG-AUT-TIP NOT = 2 GO TO E-DNA.
      **** rel 4.1
      *    MOVE 1 TO TIPOP1.
      *    MOVE RG-AUT-DNA TO GGMMAA.
           MOVE 4 TO TIPOP1.
           MOVE RG-AUT-DNA TO GGMMAA4.
      ************
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DNA.
      *
       V-SES.
           MOVE 'AUT-SES' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SES.
           IF RG-AUT-TIP NOT = 2 GO TO E-SES.
           IF NOT (RG-AUT-SES = 'M' OR 'F')
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-SES.
      *
       V-FLGNEST.
           MOVE 'AUT-FLGNEST' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLGNEST.
           IF RA-AUT-FLGNEST > 1
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF RA-AUT-FLGNEST = 1 MOVE SPACE TO RG-AUT-PNA.
       E-FLGNEST.
      *
       V-CNA.
           MOVE 'AUT-CNA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CNA.
           IF RG-AUT-TIP NOT = 2 GO TO E-CNA.
       E-CNA.
      *
       V-PNA.
           MOVE 'AUT-PNA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PNA.
           IF RG-AUT-TIP NOT = 2 GO TO E-PNA.
       E-PNA.
      *
       V-FLGDEST.
           MOVE 'AUT-FLGDEST' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLGDEST.
           IF RA-AUT-FLGDEST > 1
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF RA-AUT-FLGDEST = ZERO
              MOVE ZERO  TO RG-AUT-CDE
              MOVE SPACE TO RG-AUT-FSE.
           IF RA-AUT-FLGDEST = 1 MOVE SPACE TO RG-AUT-PDO.
       E-FLGDEST.
      *
       V-FLGDEST2.
           MOVE 'AUT-FLGDEST2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLGDEST2.
           IF RA-AUT-FLGDEST2 > 1
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF RA-AUT-FLGDEST2 = 1 MOVE SPACE TO RG-AUT-PDO2.
       E-FLGDEST2.
      *
       V-CDO.
           MOVE 'AUT-CDO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDO.
       E-CDO.
      *
       V-PDO.
           MOVE 'AUT-PDO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PDO.
      **** rel 1.2
      *    IF RG-AUT-PDO = SPACE
      *       PERFORM ERR-ZERO
      *       GO TO V-ERROR.
      ************
       E-PDO.
      *
       V-IND.
           MOVE 'AUT-IND' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IND.
       E-IND.
      *
       V-CDE.
           MOVE 'AUT-CDE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDE.
       E-CDE.
      *
       V-ATT.
           MOVE 'AUT-ATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ATT.
           IF NOT (RG-AUT-ATT = 'M' OR 'A')
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-ATT.
      *
      **** rel 7.2
       V-FORZA.
           MOVE 'AUT-FORZA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FORZA.
           IF FUN = 'V' GO TO E-FORZA.
      *
           IF RG-AUT-FORZA = ZERO
              GO TO E-FORZA.
           MOVE 'Si sta forzando come esatte le         ' TO F-MES1.
           MOVE 'segnalazioni date in fase di controllo ' TO F-MES2.
           MOVE 'del file telematico su questo soggetto.' TO F-MES3.
           MOVE 'Continuare?'                             TO F-MES4.
           MOVE 4 TO F-NMES
           MOVE 'Q' TO MB-TIPO
           MOVE 2 TO MB-DEFAULT
           CALL 'vrmbox' USING PARMB
           IF MB-RISP = 'N'
              MOVE ZERO TO RG-AUT-FORZA.
       E-FORZA.
      *
      ************
       V-TEST.
           MOVE 'AUT-TEST' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TEST.
           IF RA-AUT-TEST > 1 
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-TEST.
      * controllo eseguito sempre
           IF FLAG-FIS = ZERO GO TO END-VALIDA.
           MOVE "Codice fiscale errato" TO MESS.
           GO TO V-WARNING.
       END-VALIDA.
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
           IF RA-AUT-TPMS = 3 
              IF RA-AUT-TEST = ZERO
                 MOVE ZERO TO CLF-FLAUT
              ELSE
                 MOVE RA-AUT-TEST TO CLF-FLAUT
              END-IF
              REWRITE RF-CLF FROM REKCLF INVALID
                      PERFORM INVK-CLF
                      PERFORM VISK-AUT
                      GO TO ERRIO.
           IF RA-AUT-TPMS = 2 
              IF RA-AUT-TEST = ZERO
                 MOVE ZERO TO CON-FLAUT
              ELSE
                 MOVE RA-AUT-TEST TO CON-FLAUT
              END-IF
              REWRITE RF-CON FROM REKCON INVALID
                      PERFORM INVK-CON
                      PERFORM VISK-AUT
                      GO TO ERRIO.
      **** rel 4.0-2
           IF RA-AUT-TPMS = 3
              PERFORM DB-AGG-CFX THRU EX-DB-AGG-CFX.
           IF RA-AUT-TPMS = 2
              PERFORM DB-AGG-COL THRU EX-DB-AGG-COL.
      ************
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
      **** rel 4.0-2
       DB-AGG-CFX.
           CLOSE ANACLF.
           MOVE 'anacfx' TO ID-CLF.
           OPEN I-O ANACLF.
           MOVE KEYAT TO KEYCF.
           READ ANACLF INTO REKCLF INVALID GO TO DB-AGG-CFX-90.
           IF RA-AUT-TEST = ZERO
              MOVE ZERO TO CLF-FLAUT
           ELSE
              MOVE RA-AUT-TEST TO CLF-FLAUT.
           REWRITE RF-CLF FROM REKCLF INVALID
                      PERFORM INVK-CLF
                      PERFORM VISK-AUT
                      GO TO ERRIO.
       DB-AGG-CFX-90.
           CLOSE ANACLF.
           MOVE 'anaclf' TO ID-CLF.
           OPEN I-O ANACLF.
       EX-DB-AGG-CFX.
           EXIT.
      *------------------
       DB-AGG-COL.
           CLOSE ANACON.
           MOVE 'anacol' TO ID-CON.
           OPEN I-O ANACON.
           MOVE KEYAT TO KEYPC.
           READ ANACON INTO REKCON INVALID GO TO DB-AGG-COL-90.
           IF RA-AUT-TEST = ZERO
              MOVE ZERO TO CON-FLAUT
           ELSE
              MOVE RA-AUT-TEST TO CON-FLAUT.
           REWRITE RF-CON FROM REKCON INVALID
                      PERFORM INVK-CON
                      PERFORM VISK-AUT
                      GO TO ERRIO.
       DB-AGG-COL-90.
           CLOSE ANACON.
           MOVE 'anacon' TO ID-CON.
           OPEN I-O ANACON.
       EX-DB-AGG-COL.
           EXIT.
      *------------------
      ************
      **** rel 7.2
       SCRIVI-AAU.
           MOVE ZERO TO RF-AAU.
           MOVE SPACE TO AAU-PDO2 AAU-CDO2 AAU-IND2
                         AAU-CCOM1 AAU-CCOM2 AAU-CFUS AAU-CFUSD.
           MOVE KEYAT TO KEYAAU.
           WRITE RF-AAU.
       EX-SCRIVI-AAU.
           EXIT.
      *------------------
      ************
